/*
 * Copyright (c) 2005, Your Corporation. All Rights Reserved.
 */

package bookExamples.ch18Swing;

import javax.swing.table.AbstractTableModel;
import javax.swing.*;
import java.text.SimpleDateFormat;
import java.util.Vector;
import java.util.Date;

public class StockTableData extends AbstractTableModel {

    static final public ColumnData m_columns[] = {
            new ColumnData("Symbol", 100, JLabel.LEFT),
            new ColumnData("Name", 160, JLabel.LEFT),
            new ColumnData("Last", 100, JLabel.RIGHT),
            new ColumnData("Open", 100, JLabel.RIGHT),
            new ColumnData("Change", 100, JLabel.RIGHT),
            new ColumnData("Change %", 100, JLabel.RIGHT),
            new ColumnData("Volume", 100, JLabel.RIGHT)
    };

    protected SimpleDateFormat         sdf = new SimpleDateFormat("MM/dd/yyyy");
    protected Vector v=new Vector();
    protected Date date;

    public StockTableData() {
        setDefaultData();
    }

    public void setDefaultData() {
        try {
            date = sdf.parse("12/18/2004");
        }
        catch (java.text.ParseException ex) {
            date = null;
        }

        v.removeAllElements();
        v.addElement(new StockData("ORCL", "Oracle Corp.",
                23.6875, 25.375, -1.6875, -6.42, 24976600));
        v.addElement(new StockData("EGGS", "Egghead.com",
                17.25, 17.4375, -0.1875, -1.43, 2146400));
        v.addElement(new StockData("T", "AT&T",
                65.1875, 66, -0.8125, -0.10, 554000));
        v.addElement(new StockData("LU", "Lucent Technology",
                64.625, 59.9375, 4.6875, 9.65, 29856300));
        v.addElement(new StockData("FON", "Sprint",
                104.5625, 106.375, -1.8125, -1.82, 1135100));
        v.addElement(new StockData("ENML", "Enamelon Inc.",
                4.875, 5, -0.125, 0, 35900));
        v.addElement(new StockData("CPQ", "Compaq Computers",
                30.875, 31.25, -0.375, -2.18, 11853900));
        v.addElement(new StockData("MSFT", "Microsoft Corp.",
                94.0625, 95.1875, -1.125, -0.92, 19836900));
        v.addElement(new StockData("DELL", "Dell Computers",
                46.1875, 44.5, 1.6875, 6.24, 47310000));
        v.addElement(new StockData("SUNW", "Sun Microsystems",
                140.625, 130.9375, 10, 10.625, 17734600));
        v.addElement(new StockData("IBM", "Intl. Bus. Machines",
                183, 183.125, -0.125, -0.51, 4371400));
        v.addElement(new StockData("HWP", "Hewlett-Packard",
                70, 71.0625, -1.4375, -2.01, 2410700));
        v.addElement(new StockData("UIS", "Unisys Corp.",
                28.25, 29, -0.75, -2.59, 2576200));
        v.addElement(new StockData("SNE", "Sony Corp.",
                96.1875, 95.625, 1.125, 1.18, 330600));
        v.addElement(new StockData("NOVL", "Novell Inc.",
                24.0625, 24.375, -0.3125, -3.02, 6047900));
        v.addElement(new StockData("HIT", "Hitachi, Ltd.",
                78.5, 77.625, 0.875, 1.12, 49400));
    }

    public int getRowCount() {
        return v == null ? 0 : v.size();
    }

    public int getColumnCount() {
        return m_columns.length;
    }

    public String getColumnName(int column) {
        return m_columns[column].title;
    }

    public boolean isCellEditable(int nRow, int nCol) {
        return false;
    }

    public Object getValueAt(int nRow, int nCol) {
        if (nRow < 0 || nRow >= getRowCount())
            return "";
        StockData row = (StockData) v.elementAt(nRow);
        switch (nCol) {
            case 0:
                return row.symbol;
            case 1:
                return row.name;
            case 2:
                return row.last;
            case 3:
                return row.open;
            case 4:
                return row.change;
            case 5:
                return row.changePercent;
            case 6:
                return row.volume;
        }
        return "";
    }

    public String getTitle() {
        if (date == null)
            return "Stock Quotes";
        return "Stock Quotes at " + sdf.format(date);
    }
}
